//+----------------------------------------------------------+
//|                                                          |
//|                     Tamil.mq4                         |
//|             Copyright  2006, Nico Roets                 |
//+----------------------------------------------------------+
#property copyright "Copyright  2006, Nico Roets"
extern string EAName = "Tamil-FX";
extern bool   ManageMoney = false; 
extern double Lots = 1.0;
extern int    Risk = 3; 
extern bool   UseSound = true;
extern int    TrailingStop = 60; 
extern int    ProfitLevel = 2000; // Set this pip level if you need to close all open trades
extern bool   AccountIsMicro = true; 
extern int    StopLoss = 60; 
extern int    StartLevel=40;
//----------------------------------------------------------------------------------------------------------// 

int    MagicNo = 9559;
int    MaxTrades=1;
int    TakeProfit = 1000;

int    ticket, cnt, total;
bool   Buy, Sell; 
double TP, SL; 
string OrderCom; 
string NameFileSound="expert.wav";
string NameFileSoundClose="alert2.wav";    
bool xTime=false;
   
//----------------------------------------------------------------------------------------------------------// 

int init()
{
   
   MagicNo = GenerateMagicNoNumber(MagicNo, Symbol(), Period());
	EAName = GenerateComment(EAName, MagicNo, Period());
	
	int maxOrders = OrdersTotal();
	int t_index;
	for (t_index=0; t_index<maxOrders; t_index++)
	{
		OrderSelect(t_index, SELECT_BY_POS, MODE_TRADES);
		if (MagicNo==OrderMagicNumber())
		{			
			ticket   = OrderTicket();
			Lots     = OrderLots();
			break;
		}	
	}	
   return (0);
}
//----------------------------------------------------------------------------------------------------------// 

int deinit()
{
   return (0);
}
//----------------------------------------------------------------------------------------------------------// 

int orderscnt()
{
int cnt=0;
   for(int i =0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && MagicNo==OrderMagicNumber()){
         cnt++;
         }
      }
   }
   return(cnt);
}

//----------------------------------------------------------------------------------------------------------// 

int start()
{
  if(orderscnt()<MaxTrades){
  if(ManageMoney) Lots=subLotSize();
//----------------------------------------------------------------------------------------------------------//
 
   if (HitLevel()==1) {Buy = true;  OrderCom = "TAM_Buy"; }  
   if (HitLevel()==2) {Sell = true; OrderCom = "TAM_Sell";}   
   
 //----------------------------------------------------------------------------------------------------------// 
  
 
   if (Buy){
      if(StopLoss==0){SL=0;}else{SL=Ask-StopLoss*Point;}
      if(TakeProfit==0){TP=0;}else{TP=Ask+TakeProfit*Point;}
      OrderSend(Symbol(),OP_BUY,Lots,Ask,1,SL,TP,OrderCom,MagicNo,0,Yellow); 
      }
      
   if (Sell){
      if(StopLoss==0){SL=0;}else{SL=Bid+StopLoss*Point;}
      if(TakeProfit==0){TP=0;}else{TP=Bid-TakeProfit*Point;}
      OrderSend(Symbol(),OP_SELL,Lots,Bid,1,SL,TP,OrderCom,MagicNo,0,HotPink); 
      }
      
    xTime=false; Sell=false; Buy=false;

} 
//----------------------------------------------------------------------------------------------------------// 
  
  if(TrailingStop>0)
   {
     for(cnt=0;cnt<OrdersTotal();cnt++)
      {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNo)
         {

//----------------------------------------------------------------------------------------------------------// 

            if(OrderType()==OP_BUY) 
            {
             if(((Bid-OrderOpenPrice())/Point)>=StartLevel && OrderStopLoss()<Bid-Point*TrailingStop)
               {                                                                // OrderTakeProfit()
                OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,Ask+TakeProfit*Point,0,Green);
                if (UseSound) PlaySound(NameFileSound);
                return(0);
               }
            }
//----------------------------------------------------------------------------------------------------------// 

            if(OrderType()==OP_SELL)
            {
              if(((OrderOpenPrice()-Ask)/Point)>=StartLevel && OrderStopLoss()>Ask+Point*TrailingStop)
               {                                                                 //OrderTakeProfit()
                OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,Bid-TakeProfit*Point,0,Red);
                if (UseSound) PlaySound(NameFileSound);   
                return(0);
                }
            }
//----------------------------------------------------------------------------------------------------------// 

         }
      }
   }            
//----------------------------------------------------------------------------------------------------------// 

if ((AccountEquity() - AccountBalance())>=(ProfitLevel*Lots)) 
{
  total = OrdersTotal();
  for(int i=total-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS);
    int type   = OrderType();
    bool result = false;
    switch(type) 
    {
    case OP_BUY       : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 1, Aqua ); break;
    case OP_SELL      : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 1, Tomato );  
    }
    if (UseSound) PlaySound(NameFileSoundClose);
  }  
}

return (0);

}

//----------------------------------------------------------------------------------------------------------// 

int GenerateMagicNoNumber(int seed, string symbol, int timeFrame)
{
   int isymbol = 0;
   if (symbol == "EURUSDm") isymbol = 1;
   else if (symbol == "GBPUSDm") isymbol = 2;
   else if (symbol == "USDJPYm") isymbol = 3;
   else if (symbol == "USDCHFm") isymbol = 4;
   else if (symbol == "AUDUSDm") isymbol = 5;
   else if (symbol == "USDCADm") isymbol = 6;
   else if (symbol == "EURGBPm") isymbol = 7;
   else if (symbol == "EURJPYm") isymbol = 8;
   else if (symbol == "EURCHFm") isymbol = 9;
   else if (symbol == "EURAUDm") isymbol = 10;
   else if (symbol == "EURCADm") isymbol = 11;
   else if (symbol == "GBPUSDm") isymbol = 12;
   else if (symbol == "GBPJPYm") isymbol = 13;
   else if (symbol == "GBPCHFm") isymbol = 14;
   else if (symbol == "GBPAUDm") isymbol = 15;
   else if (symbol == "GBPCADm") isymbol = 16;
   return (StrToInteger(StringConcatenate(seed, isymbol, timeFrame)));
}

//----------------------------------------------------------------------------------------------------------// 

string GenerateComment(string EAName, int MagicNo, int timeFrame)
{
   return (StringConcatenate(EAName, "-", MagicNo, "-", timeFrame));
}

//----------------------------------------------------------------------------------------------------------// 

double subLotSize()
{
 double lotMM = MathCeil(AccountFreeMargin() *  Risk / 1000)/100;
	  
	  if(AccountIsMicro==false) //normal account
	  {
	     if(lotMM < 0.1)                  lotMM = Lots;
	     if((lotMM > 0.5) && (lotMM < 1)) lotMM = 0.5;
	     if(lotMM > 1.0)                  lotMM = MathCeil(lotMM);
	     if(lotMM > 100)                  lotMM = 100;
	  }
	  else //mini account
	  {
	     if(lotMM < 0.01)                 lotMM = Lots;
	     if(lotMM > 1.0)                  lotMM = MathCeil(lotMM);
	     if(lotMM > 100)                  lotMM = 100;
	  }
	  
	  return (lotMM);
}
 
//--------------------------------------------------------------------------------------// 

int HitLevel()
{

 double MA1=iMA(NULL,0,20,0,MODE_SMA,PRICE_MEDIAN,0);
 double MA2=iMA(NULL,0,20,0,MODE_SMA,PRICE_MEDIAN,15);
 
 double MD1=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
 double MD2=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
 
 double MS1=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
 double MS2=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1);
 
//--------------------------------------------------------------------------------------// 
  if (MA1>MA2 && MD2<0 && MD2>MS2 && MS1>MS2) return (1); 
  if (MA1<MA2 && MD2>0 && MD2<MS2 && MS1<MS2) return (2);  
//--------------------------------------------------------------------------------------// 
  
}

